std::reverse_iterator::operator[](3)

NAME
std::reverse_iterator::operator[] - std::reverse_iterator::operator[]

Synopsis
   /*unspecified*/ operator[]( difference_type n ) const; (until C++17)
   constexpr /*unspecified*/ operator[]( difference_type n ) const; (since C++17)
   Returns a reference to the element at specified relative location.

Parameters
   n - position relative to current location.

Return value
   A reference to the element at relative location, that is, base()[-n-1].

Example
// Run this code
 #include <array>
 #include <cstddef>
 #include <iostream>
 #include <iterator>
 #include <list>
 #include <vector>
 int main()
 {
     {
         int a[]{0, 1, 2, 3};
         std::reverse_iterator<int*> iter{std::rbegin(a)};
         for (std::size_t i{}; i != std::size(a); ++i)
             std::cout << iter[i] << ' '; // decltype(iter[i]) is `int&`
         std::cout << '\n';
     }
     {
         std::vector v{0, 1, 2, 3};
         std::reverse_iterator<std::vector<int>::iterator> iter{std::rbegin(v)};
         for (std::size_t i{}; i != std::size(v); ++i)
             std::cout << iter[i] << ' '; // decltype(iter[i]) is `int&`
         std::cout << '\n';
     }
     {
         // constexpr context
         constexpr static std::array<int, 4> z{0, 1, 2, 3};
         constexpr std::reverse_iterator<decltype(z)::const_iterator> it{std::crbegin(z)};
         static_assert(it[1] == 2);
     }
     {
         std::list li{0, 1, 2, 3};
         std::reverse_iterator<std::list<int>::iterator> iter{std::rbegin(li)};
         *iter = 42; // OK
     // iter[0] = 13; // compilation error ~ the underlying iterator
                       // does not model the random access iterator
     }
 }

Output:
 3 2 1 0
 3 2 1 0

See also
   operator* accesses the pointed-to element
   operator-> (public member function)